<?php

include 'AvidCue.php';
include 'ProToolsCue.php';

Class CueParser {

	public function parseEdl($file){
		
		try {
			
			debug_raw( 'Parse EDL file => ' .$file);
			$f = fopen($file,'r'); $type = fgets($f); fclose($f);
			if($f==FALSE) {
				
				debug_raw( 'Failed to open EDL => ' .$file);
				return false;
			}	
			
			debug_raw( 'Parse EDL Type => ' .$type);
			
			if(strpos($type,"SESSION NAME:")===FALSE) {
			
				$fn=$this->clean($file);
				$lines = $this->get_file($fn);
				unlink($fn);
				$header = $this->getCueType($lines);
				if($header[0]=='INVALIDEDL') {
				
					debug_raw( 'Parse EDL Invalid EDL => '  . $header[0] . ' ' .$filename);
					return false;
				
				}
				
				debug_raw( 'Cleaned EDL header => '.$header[0]);
				return $this->parseEDLTracks(($this->getEDLTracks($lines)));
	
					
			} else {

				debug_raw( 'Parse ProTools');
				$lines = $this->get_file($file);
				return $this->parseProtoolTracks($this->getProToolTracks($lines));
			}	
			
		} catch (Exception $e) {
			
				debug_raw( 'Parse EDL FAILED => ' .$e->getMessage());
				return $e->getMessage();
			
		}	
	}
	public function clean($file) {
	
	
		try{
				
			$tn = tempnam("/tmp", "FOO");
			$cn = tempnam("/tmp", "CLEAN");
			chmod($cn,0777);
	
			$cmd = "tr -cd '\\11\\12\\15\\40-\\176\' < '".$file."'|tr '\\n\\r' '\\n'|tr -d \\\"\\'\\,|egrep -v '^[ ]*$|^#' > ".$tn;
	
			//echo $cmd.PHP_EOL;
			debug_raw( 'Clean EDL  => '. $cmd);
			exec($cmd);
	
			$out = fopen($cn, 'a') or die('fopen failed');
	
			$cleaned = array();
	
			$lines = file($tn);
	
			$end=false;
			$i=0;
	
			if(strpos($lines[0],"TITLE:")===false) {
	
				$lines[0]='TITLE: '.$lines[0];
	
			}
	
			foreach ($lines as &$l) {
	
				if(is_numeric($l[0])==false){
	
					//echo $l;
					$ret = fwrite($out,$l);
					//echo "return =>".$ret.PHP_EOL;
	
					if(isset($lines[$i+1][0])) {
						if(is_numeric($lines[$i+1][0])){
	
							//echo "END".PHP_EOL;
							fwrite($out,'END'.PHP_EOL);
						}
					}
	
				} else {
	
					if(is_numeric($l[0])){
	
						//echo $l;
						fwrite($out,$l);
	
					}
				}
	
				$i++;
			}
	
			//echo "END".PHP_EOL;
			fwrite($out,'END'.PHP_EOL);
			fclose($out);
			unlink($tn);
			return $cn;
			
		} catch (Exception $e) {
	
			debug_raw( 'Clean EDL  Failed =>  '.$e);
			return "FAILED";
	
		}
	}
	private function parse_protools($result,$filename) {
	
		//$ptsess = file_get_contents(UPLOADDIR.'/'.$filename);
		if (!file_exists(PTINJEST)) {
	
			debug_raw(  'ptinjest file not found');
			return $res[0] = 'INVALIDEDL';
	
		}
	
		$cmd = PTINJEST .' '.  UPLOADDIR.'/'.$filename .' 2>&1';
			
		debug_raw(  'ptinjest => ' . $cmd);
			
			
		exec($cmd, $json);
			
		//$res[] = json_decode($json[0]);
			
			
		$cues=json_decode($json[0]);
			
		if($cues==NULL||$cues==FALSE) {
	
			debug_raw(  'ptinjest not valid json');
			return $res[0] = 'INVALIDEDL';
		}
			
			
		$sess_array[]=$cues->sessionInfo->samplerate;
		$sess_array[]=$cues->sessionInfo->importdate;
		$sess_array[]=$cues->sessionInfo->framerate;
		$sess_array[]=$cues->sessionInfo->sessionname;
			
		foreach ($cues->cues as $cs ) {
	
			foreach ($cs->trackCues as $c ) {
					
				$cues_array[]=$c->CueName;
				$cues_array[]='';
				$cues_array[]='';
				$cues_array[]='';
				$cues_array[]='';
				$cues_array[]=$c->InTime;
				$cues_array[]=$c->OutTime;
					
				$d=$c->Duration/$cues->sessionInfo->samplerate;
				//debug_raw(  'protools import duration => '.$d);
				$d = number_format($d, 2, '.', '');
				$cues_array[]=$d;
				//$cues_array[]=$c->Duration/$cues->sessionInfo->samplerate;
					
			}
		}
		$res[] = 'PARSEDFILE';
		$res[] = $filename;
		$res[] = $cues_array;
		$res[] = $sess_array;
			
		return $res;
	}
	
	/*
	private function parse_CMX3600($result,$filename) {
	
		$fname = UPLOADDIR.'/'.$filename;
			
		$f = fopen($fname,'r'); $type = fgets($f); fclose($f);
		debug_raw(  'EDL TYPE -> ' . $type . ' ' .strpos($type,"SESSION NAME:"));
			
			
		//if($header[0]=='AVID') {
		if(strpos($type,"SESSION NAME:")===FALSE) {
	
			$fn=$this->clean($fname);
	
			debug_raw(  'Parse EDL file -> ' . $fn);
				
			$lines = $this->get_file($fn);
			unlink($fn);
	
			$header = $this->getCueType($lines);
				
			if($header[0]=='INVALIDEDL') {
	
				debug_raw(  'INVALIDEDL -> ' . $header[0] . ' ' .$filename);
				return $res[0] = 'INVALIDEDL';
	
			}
	
			$sess_array[]='not known';
			$sess_array[]='not known';
			$sess_array[]=$header[2];
			$sess_array[]=$header[1];
	
			//debug_raw(  'get type -> ' .$header[1] . ' ' . $header[1]);
	
			// parse and return cues from EDL
	
			$cues = $this->parseEDLTracks(($this->getEDLTracks($lines)));
	
			$json ='[';
			$i=1;
	
			//debug_raw(  'Parse EDL file -> ' . $header[0] . ' ' .$filename . '  ' . count($cues));
	
			foreach ($cues as $cue) {
	
				//[{"row":1,"cue_name":"001","use":"","composer":"","publisher":"","in_time":"00:00:00:00","out_time":"00:00:00:21","duration":"00:02"},
					
				//debug_raw(  'Start time => '. $cue->getDurIn() );
					
				//$cues_array[]=$cue->getEditNumber();
				$cues_array[]=$cue->getFromClip();
				$cues_array[]='';
				$cues_array[]='';
				$cues_array[]='';
				$cues_array[]='';
				$cues_array[]='';
				$cues_array[]=$this->format_tc($cue->getStartTime());
				$cues_array[]=$this->format_tc($cue->getEndTime());
					
				//debug_raw(  'Start time => '. $cue->getStartTime() .' => ' .$this->tc2Sec($cue->getStartTime(),'30'));
				//debug_raw(  'End time => '. $cue->getEndTime() .' => ' .$this->tc2Sec($cue->getEndTime(),'30'));
					
				//debug_raw(  'duration '. $cue->getEditNumber() .'=> '.$this->tc2Sec($cue->getDurOut(),'30') . ' - '.$this->tc2Sec($cue->getDurIn(),'30'));
					
				//$d=($this->secToTimecode($this->tc2Sec($cue->getDurIn(),'30')-$this->tc2Sec($cue->getDurOut(),'30')));
					
				$dout=$this->tc2Sec($cue->getDurOut(),'30');
				$din=$this->tc2Sec($cue->getDurIn(),'30');
				$d=($this->formatDuration($this->tc2Sec($cue->getDurOut(),'30')-$this->tc2Sec($cue->getDurIn(),'30')));
					
				//$d=$this->format_tc($cue->getDurOut());
				//debug_raw(  'duration final => '.$d);
				//$d=substr($d,3,-3);
					
				$cues_array[]=$d;
					
				$json.="{\"seq\":".$i.",";
				$json.="\"cue_name\":\"".$cue->getFromClip()."\",";
				//$json.="\"cue_name\":\"".$cue->getEditNumber()."\",";
				$json.="\"use\":\"\",";
					$json.="\"composer\":\"\",";
					$json.="\"publisher\":\"\",";
					$json.="\"origin\":\"\",";
					$json.="\"in_time\":\"".$this->format_tc($cue->getDurIn())."\",";
						$json.="\"out_time\":\"".$this->format_tc($cue->getDurOut())."\",";
						//$json.="\"in_time\":\"".$this->format_tc($cue->getStartTime())."\",";
				//$json.="\"out_time\":\"".$this->format_tc($cue->getEndTime())."\",";
				//$json.="\"duration\":\"".$this->format_tc($d)."\"";
				$json.="\"duration\":\"".$this->format_tc($d)."\"";
				$json.="},";
							
				$i++;
					
			}
			$json=rtrim($json,',}');
			$json.="}]";
	
			//debug_raw( 'json in parse edl => ' . $json);
					
				$res[] = 'PARSEDFILE';
				$res[] = $filename;
				$res[] = $cues_array;
					$res[] = $sess_array;
					$res[] = $json;
					unlink($fname);
				return $res;
		} else {
			
		//if($header[0]=='PROTOOLS') {
		$lines = $this->get_file($fname);
		$header = $this->getCueType($lines);
		debug_raw(  'Parse Protools file -> ' . $header[0] . ' ' .$filename);
			unlink($fname);
				return $this->parseProtoolTracks($this->getProToolTracks($lines));
					
		}
		}
		
		private function parse_xml($result,$filename) {
			
		$xml = simplexml_load_file(UPLOADDIR.'/'.$filename);
		$data = get_object_vars($xml);
	
	
		debug_raw(  'parse xml => '.$filename);
	
		$header = $xml->xpath("sequence");
	
				$sess_array[]='not known';
				$sess_array[]='not known';
				$sess_array[]=(string)$header[0]->rate->timebase;
				$sess_array[]=(string)$header[0]->name;
	
				$clips = $xml->xpath("sequence/media/audio/track/clipitem");
	
				$json ='[';
		$i=1;
		foreach($clips as $clip) {
	
			//debug_raw(  'parse xml => '.$clip->out);
				$cues_array[]=(string)$clip->name;
				$cues_array[]='';
				$cues_array[]='';
				$cues_array[]='';
				$cues_array[]='';
				$cues_array[]=(string)$this->format_tc(($clip->in/30));
				$cues_array[]=(string)$this->format_tc(($clip->out/30));
					
				//debug_raw(  'clip in => '.$clip->in/30);
				//debug_raw(  'clip out => '.$clip->out/30);
					
				$dur=(($clip->out/30)-($clip->in/30));
				//$cues_array[]=($clip->duration/$header[0]->rate->timebase);
					
				//debug_raw(  'duration => '.$dur);
				$d=(string)$this->format_tc($dur);
				$d=substr($d,3,-3);
				$cues_array[]=$d;
					
	
				$json.="{\"seq\":".$i.",";
				$json.="\"cue_name\":\"".(string)$clip->name."\",";
				$json.="\"use\":\"\",";
				$json.="\"composer\":\"\",";
				$json.="\"publisher\":\"\",";
				$json.="\"origin\":\"\",";
					$json.="\"in_time\":\"".(string)$this->format_tc(($clip->in/30))."\",";
								$json.="\"out_time\":\"".(string)$this->format_tc(($clip->out/30))."\",";
								$json.="\"duration\":\"".$d."\"";
								$json.="},";
									
								$i++;
				}
	
				$json=rtrim($json,',}');
				$json.="}]";
	
		$res[] = 'PARSEDFILE';
				$res[] = $filename;
				$res[] = $cues_array;
				$res[] = $sess_array;
				$res[] = $json;
				return $res;
	
	}
	
	
	private function parse_edl($result) {
	
	$res = array();
	$lines = array();
	$header = array();
	$json="";
	
	
	debug_raw(  'get type -> ' .$result[1]);
	
	$filename = $result[1];
	
	if(substr($filename, strrpos($filename, '.') + 1)=='ptf') {
		
	return($this->parse_protools($result,$filename));
	}
	if(substr($filename, strrpos($filename, '.') + 1)=='txt'||substr($filename, strrpos($filename, '.') + 1)=='edl') {
		
	return($this->parse_CMX3600($result,$filename));
	
	}
	if(substr($filename, strrpos($filename, '.') + 1)=='xml') {
		
	return($this->parse_xml($result,$filename));
	//$this->parse_xml($result,$filename);
	}
	
		
	debug_raw(  'INVALIDEDL -> ' . $filename);
			return $res[0] = 'INVALIDEDL';
	
	}
	
	private function insert_cues($cues) {
	
	
	
	//$sql = 'SELECT *'."\n".
	//     'FROM   `cues`'."\n".
	//   'ORDER BY `cue_id` DESC'."\n".
	//  'LIMIT  0, 10';
	
	//DB::query(NULL, $sql)->execute();
	
	}
	*/
	private function get_file($fname) {
	
		$fd = fopen ($fname, "r");
	
		while (!feof ($fd))
		{
		$buffer = fgets($fd, 4096);
		$lines[] = $buffer;
	}
	fclose ($fd);
	return $lines;
	}
	private function getCueType($lines) {
	
	//debug_raw(  'get type -> ' .$lines[0] );
	$header = array();
	if(strpos($lines[0],"SESSION NAME:")!==FALSE&&strpos($lines[1],"SAMPLE RATE:")
	!==FALSE&&strpos($lines[2],"BIT DEPTH:")!==FALSE) {
	
	$header[]='PROTOOLS';
	$header[]=trim($lines[0]);
		$header[]=trim($lines[1]);
		$header[]=trim($lines[2]);
		$header[]=trim($lines[3]);
		$header[]=trim($lines[4]);
			$header[]=trim($lines[5]);
				$header[]=trim($lines[6]);
					
				return $header;
					
		} else if(strpos($lines[0],"SESSION NAME:")==FALSE) {//if(strpos($lines[0],"TITLE:")!==FALSE&&strpos($lines[1],"FCM:")!==FALSE) {
				
				
			$header[]='AVID';
			$header[]=trim($lines[0]);
			$header[]=trim($lines[1]);
			return $header;
				
		} else {
			
		$header[] = 'INVALIDEDL';
		return $header;
	}
	}
	private function getEDLTracks($lines) {
	
		$tracks = array();
		$tracklist=FALSE;
		$len=count($lines);
		$i=0;
		$cue;
	
		foreach ($lines as &$line) {
	
		$l = $line;
		if(isset($l[0])) {
		 
		if(is_numeric($l[0])){
		//if(strpos($l,"001")!==FALSE){
			$tracklist=TRUE;
    		}
		}
		if($tracklist) {
	
		preg_split('/\s+/', $l);
	
		//debug_raw(  'DEBUG get EDL tracks => '. trim($l) . ' len => ' . $len);
		if($i<($len-1)){
			
			$c=preg_split('/\s+/', $l);
			$n=preg_split('/\s+/', $lines[$i+1]);
				//debug_raw(  'DEBUG next EDL tracks => curr => '. $c[0] . ' next => ' . $n[0]);
				if(strcmp($c[0],$n[0])==0) {
	
					//debug_raw(  'DEBUG next EDL tracks => curr => '. $c[0] . ' next => ' . $n[0]);
					//continue;
					//next($lines);
					$tracks[]=trim($l);
					} else {
					//debug_raw(  ' lines '.trim($l));
					$tracks[]=trim($l);
					}
				}
					//debug_raw(  ' lines '.trim($l));
					//$tracks[]=trim($l);
			}
					$i++;
			}
			return $tracks;
	
		}
	
	
		private function parseEDLTracks($ts) {
	
					$clip_names = array();
					$ind=0;
					$_cues=null;
					$startEdit=TRUE;
					$foundName=false;
					$e='';
	
					$ignore=false;
					$tn='';
					$kc='';
					$tc='';
					
	
			try {
	
			foreach ($ts as &$t) {
	
			debug_raw(  'DEBUG parse EDL => '. $t);
			
						if($startEdit) {
							
							$startEdit=FALSE;
							$cue = new AvidCue();
	
						}
			if(isset($t[0])) {
		
			if(is_numeric($t[0])&&$ignore==false){
	
			$t=preg_replace('/\s+/', '|', $t);
			$ed=explode("|",$t);

	
			$e=$ed[0];
			if(count($ed)==8) {
			
						$cue->setEditNumber($ed[0]);
						$cue->setTrackName($ed[1]);
						$cue->setTrack($ed[2]);
						$cue->setMode($ed[3]);
						$cue->setOrigin('');
						$cue->setStartTime($ed[4]);
						$cue->setEndTime($ed[5]);
						$cue->setDurIn($ed[6]);
						$cue->setDurOut($ed[7]);
						$d=($this->formatDuration($this->tc2Sec($cue->getDurOut(),'30')-$this->tc2Sec($cue->getDurIn(),'30')));
						$cue->setDuration($d);
				debug_raw(  'DEBUG => '.$ed[0]. ' '. $ed[1]. ' ' . $ed[2]. ' '. $ed[3].' ' . $ed[4].' '. $ed[5].' ' .$ed[6].' ' .$ed[7]);
				}
			
					if(count($ed)==9) {
			
						$cue->setEditNumber($ed[0]);
						$cue->setTrackName($ed[1]);
						$cue->setTrack($ed[2]);
						$cue->setMode($ed[3]);
						$cue->setOrigin('');
						$cue->setRefEditNumber($ed[4]);
						$cue->setStartTime($ed[5]);
						$cue->setEndTime($ed[6]);
						$cue->setDurIn($ed[7]);
						$cue->setDurOut($ed[8]);
						$d=($this->formatDuration($this->tc2Sec($cue->getDurOut(),'30')-$this->tc2Sec($cue->getDurIn(),'30')));
						$cue->setDuration($d);
							debug_raw(  'DEBUG => '.$ed[0]. ' '. $ed[1]. ' ' . $ed[2]. ' '. $ed[3].' ' . $ed[4].' '. $ed[5].' ' .$ed[6].' ' .$ed[7]);
						}
			
							$ignore=true;
						}
					}

					if(strstr($t,"* FROM CLIP NAME:")!=FALSE){
	
						$tn=str_replace('* FROM CLIP NAME:','',$t);
						$tn=str_replace(array('.wav','.WAV','.MP3','.mp3','.AIFF','.aiff','.AIF','.aiff'),'',$tn);
	
						//$cue->setFromClip($tn);
						//debug_raw(  'DEBUG parse EDL CLIP  NAME '.$tn . ' ' . $e);
	
					}
	
					if(strstr($t,"* KEY CLIP NAME:")!=FALSE){
	
						$kc=str_replace('* KEY CLIP NAME:','',$t);
						$kc=str_replace(array('.wav','.WAV','.MP3','.mp3','.AIFF','.aiff','.AIF','.aiff'),'',$kc);
	
					}
					if(strstr($t,"* TO CLIP NAME:")!=FALSE){
	
						$tc=str_replace('* TO CLIP NAME:','',$t);	
						$tc=str_replace(array('.wav','.WAV','.MP3','.mp3','.AIFF','.aiff','.AIF','.aiff'),'',$tc);
					}
					
					if(strstr($t,"* COMMENT:")!=FALSE){
	
						debug_raw(  'DEBUG parse EDL comment => '. $t);
					}
					
					//debug_raw(  'DEBUG parse EDL From Clip => '. $tn);
					
					if($t=='END') {
				
					$ignore=false;
					$startEdit=TRUE;
					$_cues[]=$cue;
					//debug_raw(  'END of SECTION --------------- => '.$kc .' clip name' . $tn);
					if(strlen($tn)==0&&strlen($kc)==0&&strlen($tc)==0) {$cue->setFromClip('No Clip Name');} else {
	
						if(strlen($tc)>0){$cue->setFromClip($tc);$cue->setTrackName($tc);}
						if(strlen($kc)>0){$cue->setFromClip($kc);$cue->setTrackName($kc);}
						if(strlen($tn)>0){$cue->setFromClip($tn);$cue->setTrackName($tn);}
							
					}
				
					$tn='';
	}
	
							//debug_raw(  'DEBUG => '.$cue->getStartTime());
	}
	debug_raw(  'DEBUG return cues => '.count($_cues));
	
	//foreach ($_cues as $c) {
	//debug_raw(  'DEBUG => '.$c->getDurIn());
	//}
	
	return $_cues;
	
	} catch (Exception $e) {
	
		debug_raw(  'parse EDL failed '.$e);
		return "FAILED";
			
	}
	}
	
	
	private function tc2Sec($tc,$fs) {
	
	try {
	//debug_raw(  'TC to Sec '.$tc);
	$punct= array(":", ";", ".", ",");
					$input= str_replace( $punct, ":", $tc);
					$tc_array= explode(":", $tc);
		$wholeseconds= ($tc_array['0']*3600) + ($tc_array['1'] * 60) + ($tc_array['2']);
					$partseconds= ( $tc['3']  / $fs );
					$seconds= $wholeseconds + $partseconds;
					return $seconds;
	
					} catch (Exception $e) {
	
					debug_raw(  'tc 2 sec EDL failed '.$e);
					return "FAILED";
	
	}
	
	}
	private function getProToolTracks($lines) {
	
		//debug_raw( 'count lines '. $lines);
		$tracks;
		$res=array();
		$tracklist=FALSE;
	
		$name=explode(':',$lines[0]);
		$sample=explode(':',$lines[1]);
		$header[]=trim($name[1]);
				$header[]=trim($sample[1]);
	
				$res[]=$header;
	
		foreach ($lines as &$line) {
	
						$l = $line;
						//debug_raw( 'protools lines '.$l);
						if(strpos($l,"T R A C K  L I S T I N G")!==FALSE){
						
							$tracklist=TRUE;
	
						}
						if($tracklist) {
								$tracks[]=$l;
						}
		}
		$res[]=$tracks;
		return $res;
	}
	private function parseProtoolTracks($result) {
	
			$_cues=null;
			$sess_array = array();
			$cues_array = array();
				$res = array();
	
				$header=$result[0];
	
				$sess_array[]='not known';
				$sess_array[]=$header[1];
				$sess_array[]='not known';
				$sess_array[]=$header[0];
	
				//debug_raw( 'session name '. $sess_array[3]);
				//debug_raw( 'session sample '.$sess_array[0]);
	
				$json ='[';
		$i=1;
	
		try {
		
		foreach ($result[1] as &$t) {
	
		$cues = new ProToolsCue();
		$arr = explode("\t",$t);
	
	
	
		if($arr[0]=="1") {
	
			$cues_array[]=$arr[2];
			$cues_array[]='';
			$cues_array[]='';
			$cues_array[]='';
			$cues_array[]='';
			$cues_array[]=$this->format_tc($arr[3]);
			$cues_array[]=$this->format_tc($arr[4]);
	
	
				$d='';
				if(strchr($arr[5], '.')){
	
				$d=trim($arr[5]);
					$cues_array[]=$d;
				debug_raw(  'parse protools duration in test '.$d);
							
				} else {
			
					$d=trim($this->format_tc($arr[5]));
					$d=substr($d,3,-3);
					$cues_array[]=$d;
	
				}
						//debug_raw(  'parse protools duration '.$d);
	
	
					$cues->setTrackName($arr[2]);
					$cues->setStartTime($this->format_tc($arr[3]));
					$cues->setEndTime($this->format_tc($arr[3]));
					$cues->setDuration($d);
					
				 	$json.="{\"seq\":".$i.",";
				 	$json.="\"cue_name\":\"".$arr[2]."\",";
				 	$json.="\"use\":\"\",";
				 	$json.="\"composer\":\"\",";
				 	$json.="\"publisher\":\"\",";
				 	$json.="\"origin\":\"\",";
				 	$json.="\"in_time\":\"".$this->format_tc($arr[3])."\",";
				 	$json.="\"out_time\":\"".$this->format_tc($arr[4])."\",";
				 	$json.="\"duration\":\"".$d."\"";
					$json.="},";
				 		
				 	$i++;
	
				$_cues[]=$cues;
				}
			}
	
	
			} catch (Exception $e) {
	
					debug_raw(  'parse protools failed '.$e);
							
							
			}
	
						$json=rtrim($json,',}');
						$json.="}]";
	
						//debug_raw(  'parse protools json => '.$json);
	
	
		$res[] = 'PARSEDFILE';
		$res[] = 'filename';
		$res[] = $cues_array;
		$res[] = $sess_array;
		$res[] = $json;
		//debug_raw( 'res arr size '. count($res));
		return $_cues;
	}
function formatDuration($sec, $padHours = true) {
	
	
	//debug_raw(  'format Duration '. $sec);
					// start with a blank string
					$hms = "";
	
						// do the hours first: there are 3600 seconds in an hour, so if we divide
						// the total number of seconds by 3600 and throw away the remainder, we're
						// left with the number of hours in those seconds
						$hours = intval(intval($sec) / 3600);
	
						// add hours to $hms (with a leading 0 if asked for)
						$hms .= ($padHours)
						? str_pad($hours, 2, "0", STR_PAD_LEFT). ":"
						: $hours. ":";
	
						// dividing the total seconds by 60 will give us the number of minutes
							// in total, but we're interested in *minutes past the hour* and to get
							// this, we have to divide by 60 again and then use the remainder
							$minutes = intval(($sec / 60) % 60);
	
							// add minutes to $hms (with a leading 0 if needed)
							$hms .= str_pad($minutes, 2, "0", STR_PAD_LEFT). ":";
	
							// seconds past the minute are found by dividing the total number of seconds
							// by 60 and using the remainder
							$seconds = intval($sec % 60);
	
							// add seconds to $hms (with a leading 0 if needed)
							$hms .= str_pad($seconds, 2, "0", STR_PAD_LEFT);
	
							// done!
							return $hms;
	
						}
						function secToTimecode ($seconds=0, $subtract=0) {
						$tc= array("frames"=>"00", "seconds"=>"00", "minutes"=>"00", "hours"=>"00");
	
						$partseconds= fmod(floatval($seconds), 1);
	
						$wholeseconds= $seconds - $partseconds;
	
					//debug_raw( 'debug => '. $seconds . ' ' . $partseconds . ' ' . $wholeseconds);
	
					$tc['frames']= intval($seconds / 30 );
	
	
					//if ($subtract==1) $tc['frames']= floor( $partseconds * 30 );
					// frames
					//else $tc['frames']= floor( $partseconds * 30 );
	
	
	
					// hours
					$tc['hours']= floor( $wholeseconds / 3600 );
					$minsec= ($wholeseconds - ($tc['hours'] * 3600));
	
					// minutes
					$tc['minutes']= floor( $minsec / 60 );
	
	// seconds
	$tc['seconds']= ( $minsec - ($tc['minutes'] * 60) );
	
	// padding
	foreach ( $tc AS $key=>$value ) {
			if ($value > 0 && $value < 10) $tc["$key"]= "0".$value;
			if ($value=="0") $tc["$key"]= "00";
					}
	
					$timecode = $tc['hours'].':'.$tc['minutes'].':'.$tc['seconds'].':'.$tc['frames'];
					return $timecode;
					}
	
					function secToTc ($seconds=0, $subtract=0) {
					$tc= array("frames"=>"00", "seconds"=>"00", "minutes"=>"00", "hours"=>"00");
	
	$partseconds= fmod(floatval($seconds), 1);
	
	$wholeseconds= $seconds - $partseconds;
	
	//debug_raw( 'debug => '. $seconds . ' ' . $partseconds . ' ' . $wholeseconds);
	
	$tc['frames']= intval($seconds / 30 );
	
	
	//if ($subtract==1) $tc['frames']= floor( $partseconds * 30 );
		// frames
		//else $tc['frames']= floor( $partseconds * 30 );
	
	
	
	// hours
	$tc['hours']= floor( $wholeseconds / 3600 );
				$minsec= ($wholeseconds - ($tc['hours'] * 3600));
	
				// minutes
				$tc['minutes']= floor( $minsec / 60 );
	
					// seconds
					$tc['seconds']= ( $minsec - ($tc['minutes'] * 60) );
	
					// padding
					foreach ( $tc AS $key=>$value ) {
					if ($value > 0 && $value < 10) $tc["$key"]= "0".$value;
					if ($value=="0") $tc["$key"]= "00";
					}
	
					$timecode = $tc['hours'].':'.$tc['minutes'].':'.$tc['seconds'].':'.$tc['frames'];
					return $tc;
					}
	
					public function format_tc($tc) {
	
					if(strpos($tc,":")==FALSE) {
						
					$t=$this->secToTc($tc,1);
					$tc=$t['hours'].':'.$t['minutes'].':'.$t['seconds'].':'.$t['frames'];
						
						
					}
					//debug_raw( 'Format timecode => '. $tc);
					return $tc;
	
					}
					
}
	
?>